﻿--UAL SCRIPT BY HOT ONLINE TEAM
--EDIT BY FARMER_ANDY FOR HOF BERGMANN MAP

UAL = {};

function UAL.prerequisitesPresent(specializations)
    return true;
end;

function UAL:load(savegame)

    self.state = 1;
    
	self.moveTriggerUp = getXMLString(self.xmlFile, "vehicle.moveTriggerUp#animationName");
	self.moveTriggerDn = getXMLString(self.xmlFile, "vehicle.moveTriggerDn#animationName");
	
    self.MPCode = SpecializationUtil.callSpecializationsFunction("MPCode");    
    
    self.balesJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#index"));
    self.roundsJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#rounds"));
    self.centerJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#center"));
    self.woolJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#wool"));
	self.wool2Joint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#wool2"));
	self.appleboxJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#applebox"));
	self.milkcanJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#milkcan"));
	self.bigbagJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#bigbag"));
	self.foodbagJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#foodbag"));
	self.eggboxJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#eggbox"));
	self.barrelJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#barrel"));
	self.objectCallbackUAL = SpecializationUtil.callSpecializationsFunction("objectCallbackUAL"); 
	
	self.searcher = {};
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.balesJoint#search")) );
	local trigger2 = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.balesJoint#search2")) );
	if trigger == nil then
		print("[Error::UAL] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	if trigger2 == nil then
		print("[Error::UAL] node is OK, but trigger2 could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	self.searcher.trigger = trigger;
	self.searcher.trigger2 = trigger2;
	addTrigger( trigger, "objectCallbackUAL", self );
	addTrigger( trigger2, "objectCallbackUAL", self );
	self:playAnimation(self.moveTriggerDn, 1, nil, true);	
    
    self.balesToLoad = {};
    self.rbalesToLoad = {};
    self.woolToLoad = {};
	self.wool2ToLoad = {};
	self.appleboxToLoad = {};
	self.milkcanToLoad = {};
	self.bigbagToLoad = {};
	self.foodbagToLoad = {};
	self.eggboxToLoad = {};
	self.barrelToLoad = {};
    
	self.balesToMount = {};
    self.rbalesToMount = {};
    self.woolToMount = {};
	self.wool2ToMount = {};
	self.appleboxToMount = {};
	self.milkcanToMount = {};
	self.bigbagToMount = {};
	self.foodbagToMount = {};
	self.eggboxToMount = {};
	self.barrelToMount = {};
    
    self.baleTypes = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.baleTypes.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local filename = getXMLString(self.xmlFile, key.."#type");
        if filename ~= nil then
            table.insert(self.baleTypes, filename);
        end;
        i = i + 1;
    end;
    self.hayBales = {};

    local i = 0;
    while true do
        local key = string.format("vehicle.hayBales.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.hayBales, entry);
        end;
        i = i + 1;
    end;
    self.numMaxSquare = i;
    
    self.hayRounds = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.hayRounds.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.hayRounds, entry);
        end;
        i = i + 1;
    end;
    self.numMaxRound = i;
    
    self.wool = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.wool.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.wool, entry);
        end;
        i = i + 1;
    end;
    self.numMaxWool = i;
	
	self.wool2 = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.wool2.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.wool2, entry);
        end;
        i = i + 1;
    end;
    self.numMaxWool2 = i;
    
   self.applebox = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.applebox.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.applebox, entry);
        end;
        i = i + 1;
    end;
    self.numMaxApplebox = i;
    
	self.milkcan = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.milkcan.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.milkcan, entry);
        end;
        i = i + 1;
    end;
    self.numMaxMilkcan = i;
	
	self.bigbag = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.bigbag.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.bigbag, entry);
        end;
        i = i + 1;
    end;
    self.numMaxBigbag = i;
	
	self.foodbag = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.foodbag.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.foodbag, entry);
        end;
        i = i + 1;
    end;
    self.numMaxFoodbag = i;
	
	self.eggbox = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.eggbox.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.eggbox, entry);
        end;
        i = i + 1;
    end;
    self.numMaxEggbox = i;
	
	
	self.barrel = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.barrel.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.barrel, entry);
        end;
        i = i + 1;
    end;
    self.numMaxBarrel = i;
	
    self.i = {};
    self.workMode = false;
    
    self.counter = 0;
    self.foundIt = false;
    self.baleId = nil;
    
    self.firstTime = true;
    
    self.bales = {};
    
    self.fillLevel = 0;
    self.fillLevelMax = self.numMaxSquare;
    
    self.marker = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#index"));
    setVisibility(self.marker, false);
    self.mLeft = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#left"));
    self.mRight = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#right"));
    self.mBack = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#back"));
	self.hLeftX, self.hLeftY, self.hLeftZ = getTranslation(self.mLeft);
	self.hRightX, self.hRightY, self.hRightZ = getTranslation(self.mRight);
	self.hBackX, self.hBackY, self.hBackZ = getTranslation(self.mBack);
    self.unloadPos = 0;
	self.moveAllowed = false;
    
    self.loadTypes = {}
    local loadType = g_i18n:getText("squarebales");    
    if loadType == nil then
        loadType = "squarebales"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
    
	local loadType = g_i18n:getText("roundbales");    
    if loadType == nil then
        loadType = "roundbales"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("woolpallet");    
    if loadType == nil then
        loadType = "woolpallet"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("wool2pallet");    
    if loadType == nil then
        loadType = "wool2pallet"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("applebox");    
    if loadType == nil then
        loadType = "applebox"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("milkcan");    
    if loadType == nil then
        loadType = "milkcan"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("bigbag");    
    if loadType == nil then
        loadType = "bigbag"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("foodbag");    
    if loadType == nil then
        loadType = "foodbag"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("eggbox");    
    if loadType == nil then
        loadType = "eggbox"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("barrel");    
    if loadType == nil then
        loadType = "barrel"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);

    
    self.varbodyIDX = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.balesJoint#varBodyIndex"),0);
	
end;

function UAL:delete()
    for i, balePlace in pairs(self.hayBales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
    for i, balePlace in pairs(self.hayRounds) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
    for i, balePlace in pairs(self.wool) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.wool2) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.applebox) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.milkcan) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.bigbag) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.foodbag) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.eggbox) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, balePlace in pairs(self.barrel) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	if self.searcher.trigger ~= nil then
		removeTrigger(self.searcher.trigger);
	end;
	if self.searcher.trigger2 ~= nil then
		removeTrigger(self.searcher.trigger2);
	end;
end;

function UAL:mouseEvent(posX, posY, isDown, isUp, button)
end;

function UAL:keyEvent(unicode, sym, modifier, isDown)
end;

function UAL:update(dt)
    if self.varbodyIDX ~= 0 and self.varBody ~= nil then
        self.varBodyactIdx = Utils.getNoNil(self.varBody.activeIdx,0);
    else
        self.varBodyactIdx = 0;
    end
    if self.state == 0 then
		self.state = 1
	end
    if self.firstTime then
        self.firstTime = false;
        for k,v in pairs(self.balesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz, v.fillLevel);
            baleObject:mount(self, self.hayBales[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.baleValueScale = v.baleValueScale;
            end
            if v.wrappingState ~= nil and baleObject.setWrappingState ~= nil then
                baleObject:setWrappingState(v.wrappingState);
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.balesToLoad[k] = nil;
            self.hayBales[k].baleId = v.baleId;
        end;
        
		for k,v in pairs(self.rbalesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz, v.fillLevel);
            baleObject:mount(self, self.hayRounds[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.baleValueScale = v.baleValueScale;
            end
            if v.wrappingState ~= nil and baleObject.setWrappingState ~= nil then
                baleObject:setWrappingState(v.wrappingState);
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.rbalesToLoad[k] = nil;
            self.hayRounds[k].baleId = v.baleId;
        end;
        
		for k,v in pairs(self.woolToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.wool[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.woolToLoad[k] = nil;
            self.wool[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.wool2ToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.wool2[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.wool2ToLoad[k] = nil;
            self.wool2[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.appleboxToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.applebox[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.appleboxToLoad[k] = nil;
            self.applebox[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.milkcanToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.milkcan[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.milkcanToLoad[k] = nil;
            self.milkcan[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.bigbagToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.bigbag[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.bigbagToLoad[k] = nil;
            self.bigbag[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.foodbagToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.foodbag[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.foodbagToLoad[k] = nil;
            self.foodbag[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.eggboxToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.eggbox[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.eggboxToLoad[k] = nil;
            self.eggbox[k].baleId = v.baleId;
        end;
		
		for k,v in pairs(self.barrelToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.barrel[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.barrelToLoad[k] = nil;
            self.barrel[k].baleId = v.baleId;
        end;
				
        for k, baleToMount in pairs(self.balesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.balesToMount[k] = nil;
            end;
        end;
        
		for k, baleToMount in pairs(self.rbalesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.rbalesToMount[k] = nil;
            end;
        end;
        
		for k, baleToMount in pairs(self.woolToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.woolToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.wool2ToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.wool2ToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.appleboxToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.appleboxToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.milkcanToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.milkcanToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.bigbagToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.bigbagToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.foodbagToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.foodbagToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.eggboxToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.eggboxToMount[k] = nil;
            end;
        end;
		
		for k, baleToMount in pairs(self.barrelToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.barrelToMount[k] = nil;
            end;
        end;
	end;
    
	if self:getIsActiveForInput() and self:getIsActive() and self.varBodyactIdx == self.varbodyIDX then
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
            if self.counter ~= self.fillLevelMax then
                setVisibility(self.marker, false);
                self.unloadPos = 0;
				self.moveAllowed = false;
                self:MPCode(99, not self.workMode, 0, 0, 0, false);
            end;
        end;
    
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA4) then
            if self.counter == 0 and not self.workMode then
                self.state = self.state + 1;
                if self.state > 10 then
                    self.state = 1;
                end
                self:MPCode(98, false, self.state, 0, 0, false);
            end
        end
        
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
            if self.counter >= 1 and not self.workMode then
                self.unloadPos = self.unloadPos + 1;
				self.moveAllowed = true;
                if self.unloadPos > 3 then
                    self.unloadPos = 0;
					self.moveAllowed = false;
                end

                if self.unloadPos == 0 then
                    setVisibility(self.marker, false);
                    local x,y,z = getTranslation(self.centerJoint)
                    setTranslation(self.marker, x,y,z)
                elseif  self.unloadPos == 1 then
                    setVisibility(self.marker, true);
                    local x,y,z = getTranslation(self.mLeft)
                    setTranslation(self.marker, x,y,z)
                elseif  self.unloadPos == 2 then
                    setVisibility(self.marker, true);
                    local x,y,z = getTranslation(self.mRight)
                    setTranslation(self.marker, x,y,z)
                elseif  self.unloadPos == 3 then
                    setVisibility(self.marker, true);
                    local x,y,z = getTranslation(self.mBack)
                    setTranslation(self.marker, x,y,z)
                end;
            end;
        end
		
		if self.moveAllowed then
			local moveSpeed = 0.03;
			local xAttacher, yAttacher, zAttacher = getTranslation(self.mBack);
			if InputBinding.isPressed(InputBinding.UALUP) then
				yAttacher = yAttacher + moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALDOWN) then
				yAttacher = yAttacher - moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALLEFT) then
				xAttacher = xAttacher + moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALRIGHT) then
				xAttacher = xAttacher - moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALHOME) then
				yAttacher = self.hBackY;
				xAttacher = self.hBackX;
			end;
			setTranslation(self.mBack, xAttacher, yAttacher, self.hBackZ);
			setTranslation(self.mLeft, self.hLeftX+xAttacher, yAttacher, self.hLeftZ);
			setTranslation(self.mRight, self.hRightX+xAttacher, yAttacher, self.hRightZ);
            if  self.unloadPos == 1 then
                setTranslation(self.marker, getTranslation(self.mLeft))
            elseif  self.unloadPos == 2 then
                setTranslation(self.marker, getTranslation(self.mRight))
            elseif  self.unloadPos == 3 then
                setTranslation(self.marker, getTranslation(self.mBack))
            end;
		end
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
            if self.counter >= 1 and not self.workMode then
				local aAttacher, bAttacher, cAttacher = getTranslation(self.mBack);
				self:MPCode(24, false, self.unloadPos, bAttacher, aAttacher, false);
            end;
        end;
    end;
    
    if self.varBodyactIdx ~= self.varbodyIDX and self.workMode then
		self:MPCode(99, false, 0, 0, 0, false);
    end;
end;

function UAL:draw()
    if self.varBodyactIdx == self.varbodyIDX then

        if self.counter < self.fillLevelMax then
            if not self.workMode then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE_on"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE_off"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
			end;
        end;
        
        if self.counter >= 1 and not self.workMode then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
            if self.unloadPos == 0 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_C"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
            elseif self.unloadPos == 1 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_L"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALUPDOWN"), self.typeDesc), InputBinding.UALUPDOWN);
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALLEFTRIGHT"), self.typeDesc), InputBinding.UALLEFTRIGHT);
            elseif self.unloadPos == 2 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_R"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALUPDOWN"), self.typeDesc), InputBinding.UALUPDOWN);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALLEFTRIGHT"), self.typeDesc), InputBinding.UALLEFTRIGHT);
            elseif self.unloadPos == 3 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_B"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALUPDOWN"), self.typeDesc), InputBinding.UALUPDOWN);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALLEFTRIGHT"), self.typeDesc), InputBinding.UALLEFTRIGHT);
            end;
        end;
    
        if self.counter == 0 and not self.workMode then
            g_currentMission:addHelpButtonText(string.format(self.loadTypes[self.state].text, self.typeDesc), InputBinding.IMPLEMENT_EXTRA4);
        end;
    end;
end;

function UAL:MPCode(mode, bool, state, dif, olddif, noEventSend)
    MPEvent.sendEvent(self, mode, bool, state, dif, olddif, noEventSend);
    if mode == 21 then    
        
        self.baleId = dif;
        local object = networkGetObject(self.baleId);
        if object == nil then
            return;
        end;
		if self.counter >= self.fillLevelMax then
			return;
        end;
		
        self.counter = self.counter + 1;        
        self.fillLevel = self.counter;

        if state==1 then
            object:mount(self, self.hayBales[self.counter].node, 0,0,0, 0,0,0);
            self.hayBales[self.counter].baleId = self.baleId;
        elseif state==2 then
            object:mount(self, self.hayRounds[self.counter].node, 0,0,0, 0,0,0);
            self.hayRounds[self.counter].baleId = self.baleId;
        elseif state==3 then
            object:mount(self, self.wool[self.counter].node, 0,0,0, 0,0,0);
            self.wool[self.counter].baleId = self.baleId;
        elseif state==4 then
            object:mount(self, self.wool2[self.counter].node, 0,0,0, 0,0,0);
            self.wool2[self.counter].baleId = self.baleId;
		elseif state==5 then
            object:mount(self, self.applebox[self.counter].node, 0,0,0, 0,0,0);
            self.applebox[self.counter].baleId = self.baleId;	
		elseif state==6 then
            object:mount(self, self.milkcan[self.counter].node, 0,0,0, 0,0,0);
            self.milkcan[self.counter].baleId = self.baleId;	
        elseif state==7 then
            object:mount(self, self.bigbag[self.counter].node, 0,0,0, 0,0,0);
            self.bigbag[self.counter].baleId = self.baleId;		
		elseif state==8 then
            object:mount(self, self.foodbag[self.counter].node, 0,0,0, 0,0,0);
            self.foodbag[self.counter].baleId = self.baleId;
        elseif state==9 then
            object:mount(self, self.eggbox[self.counter].node, 0,0,0, 0,0,0);
            self.eggbox[self.counter].baleId = self.baleId;	
        elseif state==10 then
            object:mount(self, self.barrel[self.counter].node, 0,0,0, 0,0,0);
            self.barrel[self.counter].baleId = self.baleId;						
        
		end;
        
        self.fillLevelMax = self.numMaxSquare;
        if state == 2 then
            self.fillLevelMax = self.numMaxRound;
        end
        if state == 3 then
            self.fillLevelMax = self.numMaxWool;
        end
		
		if state == 4 then
            self.fillLevelMax = self.numMaxWool2;
        end
		
		if state == 5 then
            self.fillLevelMax = self.numMaxApplebox;
        end
		
		if state == 6 then
            self.fillLevelMax = self.numMaxMilkcan;
        end
		
		if state == 7 then
            self.fillLevelMax = self.numMaxBigbag;
        end
		
		if state == 8 then
            self.fillLevelMax = self.numMaxFoodbag;
        end
		
		if state == 9 then
            self.fillLevelMax = self.numMaxEggbox;
        end
		
		if state == 10 then
            self.fillLevelMax = self.numMaxBarrel;
        end
		
		self.capacity = self.fillLevelMax;
        
        self.foundIt = false;
        self.baleId = nil;

    elseif mode == 24 then
        
        if state == 0 then
            local x,y,z = getTranslation(self.centerJoint)
            setTranslation(self.balesJoint, x,y,z)
            setTranslation(self.roundsJoint, x,y,z)
            setTranslation(self.woolJoint, x,y,z)
			setTranslation(self.wool2Joint, x,y,z)
			setTranslation(self.appleboxJoint, x,y,z)
			setTranslation(self.milkcanJoint, x,y,z)
			setTranslation(self.bigbagJoint, x,y,z)
			setTranslation(self.foodbagJoint, x,y,z)
			setTranslation(self.eggboxJoint, x,y,z)
			setTranslation(self.barrelJoint, x,y,z)
        elseif state == 1 then
            local x,y,z = getTranslation(self.mLeft)
            setTranslation(self.balesJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.woolJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.appleboxJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.milkcanJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.bigbagJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.foodbagJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.eggboxJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, self.hLeftX+olddif,dif-1.1,z)
        elseif state == 2 then
            local x,y,z = getTranslation(self.mRight)
            setTranslation(self.balesJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.woolJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.appleboxJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.milkcanJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.bigbagJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.foodbagJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.eggboxJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, self.hRightX+olddif,dif-1.1,z)
        elseif state == 3 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
			setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
			setTranslation(self.milkcanJoint, olddif,dif-1.1,z)
			setTranslation(self.bigbagJoint, olddif,dif-1.1,z)
			setTranslation(self.foodbagJoint, olddif,dif-1.1,z)
			setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, olddif,dif-1.1,z)
		elseif state == 4 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
            setTranslation(self.bigbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.foodbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, olddif,dif-1.1,z)
        elseif state == 5 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
			setTranslation(self.bigbagJoint, olddif,dif-1.1,z)	
			setTranslation(self.foodbagJoint, olddif,dif-1.1,z)	
			setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, olddif,dif-1.1,z)
		elseif state == 6 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
            setTranslation(self.bigbagJoint, olddif,dif-1.1,z)
			setTranslation(self.foodbagJoint, olddif,dif-1.1,z)
			setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, olddif,dif-1.1,z)
        elseif state == 7 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
            setTranslation(self.bigbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.foodbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
            setTranslation(self.barrelJoint, olddif,dif-1.1,z)			
         elseif state == 8 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
            setTranslation(self.bigbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.foodbagJoint, olddif,dif-1.1,z)		
			setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
			setTranslation(self.barrelJoint, olddif,dif-1.1,z)
		 elseif state == 9 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
            setTranslation(self.bigbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.foodbagJoint, olddif,dif-1.1,z)		
			setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
            setTranslation(self.barrelJoint, olddif,dif-1.1,z)		
        elseif state == 10 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
			setTranslation(self.wool2Joint, olddif,dif-1.1,z)
            setTranslation(self.appleboxJoint, olddif,dif-1.1,z)
            setTranslation(self.milkcanJoint, olddif,dif-1.1,z)	
            setTranslation(self.bigbagJoint, olddif,dif-1.1,z)	
            setTranslation(self.foodbagJoint, olddif,dif-1.1,z)		
			setTranslation(self.eggboxJoint, olddif,dif-1.1,z)
            setTranslation(self.barrelJoint, olddif,dif-1.1,z)				
			
        end
        
        for _, balePlace in pairs(self.hayBales) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
    
        for _, balePlace in pairs(self.hayRounds) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
        for _, balePlace in pairs(self.wool) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
		
		for _, balePlace in pairs(self.wool2) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
		
		for _, balePlace in pairs(self.applebox) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
		
		for _, balePlace in pairs(self.milkcan) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
		
		for _, balePlace in pairs(self.bigbag) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
		
		for _, balePlace in pairs(self.foodbag) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
		
		for _, balePlace in pairs(self.eggbox) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
    
	    for _, balePlace in pairs(self.barrel) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
                end;
                balePlace.baleId = nil;
            end;
        end;
	   
        self.counter = 0;
        self.fillLevel = 0;

        setVisibility(self.marker, false);
        local x,y,z = getTranslation(self.centerJoint)
        setTranslation(self.marker, x,y,z)
        self.unloadPos = 0;
		self.moveAllowed = false;
        local x,y,z = getTranslation(self.centerJoint)
        setTranslation(self.balesJoint, x,y,z)
        setTranslation(self.roundsJoint, x,y,z)
        setTranslation(self.woolJoint, x,y,z)
		setTranslation(self.wool2Joint, x,y,z)
		setTranslation(self.appleboxJoint, x,y,z)
		setTranslation(self.milkcanJoint, x,y,z)
		setTranslation(self.bigbagJoint, x,y,z)
		setTranslation(self.foodbagJoint, x,y,z)
		setTranslation(self.eggboxJoint, x,y,z)
		setTranslation(self.barrelJoint, x,y,z)
		
		setTranslation(self.mBack, self.hBackX, self.hBackY, self.hBackZ);
		setTranslation(self.mLeft, self.hLeftX, self.hLeftY, self.hLeftZ);
		setTranslation(self.mRight, self.hRightX, self.hRightY, self.hRightZ);
        
    elseif mode == 98 then
        self.state = state;
        
    elseif mode == 99 then
        self.workMode = bool;
		if self.workMode then
			self:playAnimation(self.moveTriggerUp, 1, nil, true);
		else
			self:playAnimation(self.moveTriggerDn, 1, nil, true);
		end
    end;
end;

function UAL:updateTick(dt)
end;
--[[
function UAL:postLoad(savegame)
	if savegame == nil or savegame.resetVehicles then
		return
	end
	
	local key = savegame.key
    self.counter = Utils.getNoNil(getXMLInt(savegame.xmlFile, key.."#numBales"),0);
    self.state = Utils.getNoNil(getXMLInt(savegame.xmlFile, key.."#baleMode"),0);
    self.fillLevel = self.counter;
    self.capacity = self.numMaxSquare;
    if self.state == 2 then
        self.capacity = self.numMaxRound;
    end
    if self.state == 3 then
        self.capacity = self.numMaxWool;
    end
	if self.state == 4 then
        self.capacity = self.numMaxWool2;
    end
	
	if self.state == 5 then
        self.capacity = self.numMaxApplebox;
    end
	
	if self.state == 6 then
        self.capacity = self.numMaxMilkcan;
    end
	
	if self.state == 7 then
        self.capacity = self.numMaxBigbag;
    end
	
	if self.state == 8 then
        self.capacity = self.numMaxFoodbag;
    end
   
    if self.varbodyIDX ~= 0 and self.varBody ~= nil then
        self.varBodyactIdx = Utils.getNoNil(self.varBody.activeIdx,0);
    else
        self.varBodyactIdx = 0;
    end
    if self.varbodyIDX ~= self.varBodyactIdx then
        self.capacity = self.varBody.nodes[self.varBodyactIdx].capacity;
    end
    self.fillLevelMax = self.capacity;
        
    local i=0;
    while true do
        local baleKey = key..string.format(".bale(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, bale "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.hayBales) then
                    parentNode = self.hayBales[balePlace].node;
                    bales = self.hayBales[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.balesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
        
    local i=0;
    while true do
        local baleKey = key..string.format(".rbale(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, rbale "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.hayRounds) then
                    parentNode = self.hayRounds[balePlace].node;
                    bales = self.hayRounds[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.rbalesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
    
    local i=0;
    while true do
        local baleKey = key..string.format(".wool(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, wool "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.wool) then
                    parentNode = self.wool[balePlace].node;
                    bales = self.wool[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.woolToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;

	local i=0;
    while true do
        local baleKey = key..string.format(".wool2(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, wool2 "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.wool2) then
                    parentNode = self.wool2[balePlace].node;
                    bales = self.wool2[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.wool2ToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
  
    local i=0;
    while true do
        local baleKey = key..string.format(".applebox(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, applebox "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.applebox) then
                    parentNode = self.applebox[balePlace].node;
                    bales = self.applebox[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.appleboxToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;  
	
	local i=0;
    while true do
        local baleKey = key..string.format(".milkcan(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, milkcan "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.milkcan) then
                    parentNode = self.milkcan[balePlace].node;
                    bales = self.milkcan[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.milkcanToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;  
	
	local i=0;
    while true do
        local baleKey = key..string.format(".bigbag(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, bigbag "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.bigbag) then
                    parentNode = self.bigbag[balePlace].node;
                    bales = self.bigbag[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.bigbagToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;  
	
	local i=0;
    while true do
        local baleKey = key..string.format(".foodbag(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, foodbag "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.foodbag) then
                    parentNode = self.foodbag[balePlace].node;
                    bales = self.foodbag[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.foodbagToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;  
	
    return BaseMission.VEHICLE_LOAD_OK;
end;
function UAL:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'numBales="'..tostring(self.counter)..'"'..' baleMode="'..tostring(self.state)..'"';
    local nodes = "";
    local baleNum = 0;
    
    for i, balePlace in pairs(self.hayBales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<bale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
    
    local baleNum = 0;
    for i, balePlace in pairs(self.hayRounds) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<rbale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
    
    local baleNum = 0;
    for i, balePlace in pairs(self.wool) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<wool filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;

	local baleNum = 0;
    for i, balePlace in pairs(self.wool2) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<wool2 filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
	local baleNum = 0;
    for i, balePlace in pairs(self.applebox) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<applebox filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
	local baleNum = 0;
    for i, balePlace in pairs(self.milkcan) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<milkcan filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
	local baleNum = 0;
    for i, balePlace in pairs(self.bigbag) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<bigbag filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
	local baleNum = 0;
    for i, balePlace in pairs(self.foodbag) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<foodbag filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
    return attributes,nodes;
end;
]]
function UAL:readStream(streamId, connection)
    self.workMode = streamReadBool(streamId);
    self.counter = streamReadInt32(streamId);
    
    self.fillLevel = streamReadFloat32(streamId);
    self.state = streamReadInt32(streamId);
    
	for i=1, table.getn(self.hayBales) do
        local baleServerId = streamReadFloat32(streamId);
        if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.hayBales[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.balesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.hayBales[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    for i=1, table.getn(self.hayRounds) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.hayRounds[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.rbalesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.hayRounds[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    for i=1, table.getn(self.wool) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.wool[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.woolToMount[baleServerId] = {serverId=baleServerId, linkNode=self.wool[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.wool2) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.wool2[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.wool2ToMount[baleServerId] = {serverId=baleServerId, linkNode=self.wool2[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.applebox) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.applebox[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.appleboxToMount[baleServerId] = {serverId=baleServerId, linkNode=self.applebox[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.milkcan) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.milkcan[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.milkcanToMount[baleServerId] = {serverId=baleServerId, linkNode=self.milkcan[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.bigbag) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.bigbag[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.bigbagToMount[baleServerId] = {serverId=baleServerId, linkNode=self.bigbag[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.foodbag) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.foodbag[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.foodbagToMount[baleServerId] = {serverId=baleServerId, linkNode=self.foodbag[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.eggbox) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.eggbox[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.eggboxToMount[baleServerId] = {serverId=baleServerId, linkNode=self.eggbox[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	
	for i=1, table.getn(self.barrel) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.barrel[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.barrelToMount[baleServerId] = {serverId=baleServerId, linkNode=self.barrel[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
end;

function UAL:writeStream(streamId, connection)

    streamWriteBool(streamId, self.workMode);
    streamWriteInt32(streamId, self.counter);

    streamWriteFloat32(streamId, self.fillLevel);
    streamWriteInt32(streamId, self.state);
    
    for i=1, table.getn(self.hayBales) do
        local baleServerId = Utils.getNoNil(self.hayBales[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
    for i=1, table.getn(self.hayRounds) do
		local baleServerId = Utils.getNoNil(self.hayRounds[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
    for i=1, table.getn(self.wool) do
		local baleServerId = Utils.getNoNil(self.wool[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	for i=1, table.getn(self.wool2) do
		local baleServerId = Utils.getNoNil(self.wool2[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	for i=1, table.getn(self.applebox) do
		local baleServerId = Utils.getNoNil(self.applebox[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	
	for i=1, table.getn(self.milkcan) do
		local baleServerId = Utils.getNoNil(self.milkcan[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	
	for i=1, table.getn(self.bigbag) do
		local baleServerId = Utils.getNoNil(self.bigbag[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	
	for i=1, table.getn(self.foodbag) do
		local baleServerId = Utils.getNoNil(self.foodbag[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	
	for i=1, table.getn(self.eggbox) do
		local baleServerId = Utils.getNoNil(self.eggbox[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	
	for i=1, table.getn(self.barrel) do
		local baleServerId = Utils.getNoNil(self.barrel[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
end;

function UAL:objectCallbackUAL(triggerId, otherId, onEnter, onLeave, onStay)
	
	if onEnter and self.workMode then
		local object = g_currentMission:getNodeObject(otherId);
		if object == nil or object.mountObject ~= nil then
			return
		end
		if self.counter >= self.fillLevelMax then
			return
		end
		
		if self.isServer and (object:isa(Bale) or object:isa(FillablePallet)) then
			self.foundIt = false;
			local baleDiameter = tonumber(getUserAttribute(object.nodeId, "baleDiameter"));
			local isRoundbale = Utils.getNoNil(getUserAttribute(object.nodeId, "isRoundbale"), false);
			
			if baleDiameter == nil then
				local baleDiameter = 0;
			end
    
			self.baleId = nil;
			if (self.state == 1 and not isRoundbale and (object:isa(Bale))) or
			(self.state == 2 and isRoundbale and baleDiameter <= 1.3) or
			(self.state == 3 and object:isa(FillablePallet)) or
			(self.state == 4 and object:isa(FillablePallet)) or
			(self.state == 5 and object:isa(FillablePallet)) or
			(self.state == 6 and object:isa(FillablePallet)) or
			(self.state == 7 and object:isa(FillablePallet)) or
			(self.state == 8 and object:isa(FillablePallet)) or
			(self.state == 9 and object:isa(FillablePallet)) or
			(self.state == 10 and object:isa(FillablePallet)) then
				self.foundIt = true;
				self.baleId = networkGetObjectId(object);
				self:MPCode(21, false, self.state, self.baleId, 0, false);
				if self.counter == self.fillLevelMax then
					self:MPCode(99, false, 0, 0, 0, false);
				end;
			end;

		end
	end;
end;